/* Process model C form file: fy_pc_fifo_1.pr.c */
/* Portions of this file copyright 1992, 1996 by MIL 3, Inc. */



/* OPNET system definitions */
#include <opnet.h>
#include "/usr/people/jma2/qosip/gwy_queue/fy_pc_fifo_1.pr.h"
FSM_EXT_DECS



/* Header block */
#define ARR_Q_EMPTY  (op_intrpt_type () == OPC_INTRPT_STRM && \
                      op_stat_local_read(0) == 0.0)
#define ARR_Q_BUSY   (op_intrpt_type () == OPC_INTRPT_STRM && \
                      op_stat_local_read(0) == 1.0)
#define SERVICE      op_intrpt_type () == OPC_INTRPT_STAT

/*#define SIM_END      (op_intrpt_type () == OPC_INTRPT_ENDSIM)*/

#define QUEUE_DEPTH		0
#define ARRIVAL_PT_Q_LENGTH_STAT 1
#define LATEST_Q_LENGTH_STAT 2
#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		_fstack_local_info.last_line_passed = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	_fstack_local_info.last_line_passed = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	FSM_SYS_STATE
	double                  		sv_thru;
	double                  		sv_NoOfPacketsInQueue;
	} fy_pc_fifo_1_state;

#define pr_state_ptr            		((fy_pc_fifo_1_state*) SimI_Mod_State_Ptr)
#define thru                    		pr_state_ptr->sv_thru
#define NoOfPacketsInQueue      		pr_state_ptr->sv_NoOfPacketsInQueue

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	fy_pc_fifo_1_state *op_sv_ptr = pr_state_ptr;




/* Process model interrupt handling procedure */



void
fy_pc_fifo_1 ()
	{
	packet          *pkptr;
	
	
	int _block_origin = 0;


	FSM_ENTER (fy_pc_fifo_1)

	FSM_BLOCK_SWITCH
		{
		/*---------------------------------------------------------*/
		/** state (INS_TAIL) enter executives **/
		FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "INS_TAIL", "fy_pc_fifo_1 () [INS_TAIL enter execs]")
			{
			/* a new packet has arrived; acquire it */
			pkptr = op_pk_get (op_intrpt_strm ());
			
			/*queue_length = op_subq_stat(0, OPC_QSTAT_PKSIZE);*/
			
			/* update arrival point queue statistics */
			/*op_stat_local_write(ARRIVAL_PT_Q_LENGTH_STAT, queue_length);*/
			
			/* insert the new packet at tail of subqueue 0 */
			if (op_subq_pk_insert (0, pkptr, OPC_QPOS_TAIL) != 
			            OPC_QINS_OK)
			{
				/* if the insertion failed, discard the packet */
				op_pk_destroy (pkptr);
			}
			
			NoOfPacketsInQueue++;
			thru = NoOfPacketsInQueue/op_sim_time();
			op_stat_local_write(QUEUE_DEPTH, thru );
			
			/* update latest queue length statistic */
			/*queue_length = op_subq_stat(0, OPC_QSTAT_PKSIZE);
			op_stat_local_write(LATEST_Q_LENGTH_STAT, queue_length);*/
			
			}


		/** state (INS_TAIL) exit executives **/
		FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "INS_TAIL", "fy_pc_fifo_1 () [INS_TAIL exit execs]")
			{
			}


		/** state (INS_TAIL) transition processing **/
		FSM_TRANSIT_FORCE (2, state2_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (SND_HD) enter executives **/
		FSM_STATE_ENTER_FORCED (1, state1_enter_exec, "SND_HD", "fy_pc_fifo_1 () [SND_HD enter execs]")
			{
			/* a request has been made to access the queue */
			/* check if its empty */
			if (!op_subq_empty (0))
			{
				/* access the first packet in the subqueue */
				pkptr = op_subq_pk_remove (0, OPC_QPOS_HEAD);
			
				/* forward it to the destination */
				/* causing a stream interrupt */
				/* because we are using stat interrupt not access */
				op_pk_send (pkptr, 0);
			
				NoOfPacketsInQueue--;
				thru = NoOfPacketsInQueue/op_sim_time();
				op_stat_local_write(QUEUE_DEPTH, thru );
			}
			}


		/** state (SND_HD) exit executives **/
		FSM_STATE_EXIT_FORCED (1, state1_exit_exec, "SND_HD", "fy_pc_fifo_1 () [SND_HD exit execs]")
			{
			}


		/** state (SND_HD) transition processing **/
		FSM_TRANSIT_FORCE (2, state2_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (BRANCH) enter executives **/
		FSM_STATE_ENTER_UNFORCED (2, state2_enter_exec, "BRANCH", "fy_pc_fifo_1 () [BRANCH enter execs]")
			{
			
			}


		/** blocking after enter executives of unforced state. **/
		FSM_EXIT (5,fy_pc_fifo_1)


		/** state (BRANCH) exit executives **/
		FSM_STATE_EXIT_UNFORCED (2, state2_exit_exec, "BRANCH", "fy_pc_fifo_1 () [BRANCH exit execs]")
			{
			}


		/** state (BRANCH) transition processing **/
		FSM_INIT_COND (SERVICE)
		FSM_TEST_COND (ARR_Q_BUSY)
		FSM_TEST_COND (ARR_Q_EMPTY)
		FSM_TEST_LOGIC ("BRANCH")

		FSM_TRANSIT_SWITCH
			{
			FSM_CASE_TRANSIT (0, 1, state1_enter_exec, ;)
			FSM_CASE_TRANSIT (1, 0, state0_enter_exec, ;)
			FSM_CASE_TRANSIT (2, 3, state3_enter_exec, ;)
			}
		/*---------------------------------------------------------*/



		/** state (SND_ARR) enter executives **/
		FSM_STATE_ENTER_FORCED (3, state3_enter_exec, "SND_ARR", "fy_pc_fifo_1 () [SND_ARR enter execs]")
			{
			/* there is an arrival and the server is free */
			/* get the packet pointer and send the packet */
			/* update  queue statistics */
			
			/* update queue  statistics */
			/*op_stat_local_write(ARRIVAL_PT_Q_LENGTH_STAT, 0);
			op_stat_local_write(LATEST_Q_LENGTH_STAT, 0);*/
			
			NoOfPacketsInQueue++;
			thru = NoOfPacketsInQueue/op_sim_time();
			op_stat_local_write(QUEUE_DEPTH, thru );
			
			pkptr = op_pk_get (op_intrpt_strm ());
			op_pk_send (pkptr, 0);
			}


		/** state (SND_ARR) exit executives **/
		FSM_STATE_EXIT_FORCED (3, state3_exit_exec, "SND_ARR", "fy_pc_fifo_1 () [SND_ARR exit execs]")
			{
			}


		/** state (SND_ARR) transition processing **/
		FSM_TRANSIT_FORCE (2, state2_enter_exec, ;)
		/*---------------------------------------------------------*/



		/** state (INIT) enter executives **/
		FSM_STATE_ENTER_FORCED (4, state4_enter_exec, "INIT", "fy_pc_fifo_1 () [INIT enter execs]")
			{
			}


		/** state (INIT) exit executives **/
		FSM_STATE_EXIT_FORCED (4, state4_exit_exec, "INIT", "fy_pc_fifo_1 () [INIT exit execs]")
			{
			}


		/** state (INIT) transition processing **/
		FSM_TRANSIT_FORCE (2, state2_enter_exec, ;)
		/*---------------------------------------------------------*/



		}


	FSM_EXIT (4,fy_pc_fifo_1)
	}




void
fy_pc_fifo_1_svar (prs_ptr,var_name,var_p_ptr)
	fy_pc_fifo_1_state		*prs_ptr;
	char			*var_name, **var_p_ptr;
	{

	FIN (fy_pc_fifo_1_svar (prs_ptr))

	*var_p_ptr = VOS_NIL;
	if (Vos_String_Equal ("thru" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_thru);
	if (Vos_String_Equal ("NoOfPacketsInQueue" , var_name))
		*var_p_ptr = (char *) (&prs_ptr->sv_NoOfPacketsInQueue);

	FOUT;
	}




void
fy_pc_fifo_1_diag ()
	{
	packet          *pkptr;
	
	
	int _block_origin;

	FIN (fy_pc_fifo_1_diag ())

	BINIT

	FOUT;
	}




void
fy_pc_fifo_1_terminate ()
	{
	packet          *pkptr;
	
	
	int _block_origin;

	FIN (fy_pc_fifo_1_terminate ())

	BINIT

	FOUT;
	}



Compcode
fy_pc_fifo_1_init (pr_state_pptr)
	fy_pc_fifo_1_state			**pr_state_pptr;
	{
	int _block_origin = 0;
	static VosT_Cm_Obtype	obtype = OPC_NIL;

	extern int				Vos_Nop ();

	FIN (fy_pc_fifo_1_init (pr_state_pptr))

	if (obtype == OPC_NIL)
		{
		if (Vos_Catmem_Register ("proc state vars (fy_pc_fifo_1)",
			sizeof (fy_pc_fifo_1_state), Vos_Nop, &obtype) == VOSC_FAILURE)
			FRET (OPC_COMPCODE_FAILURE)
		}

	if ((*pr_state_pptr = (fy_pc_fifo_1_state*) Vos_Catmem_Alloc (obtype, 1)) == OPC_NIL)
		FRET (OPC_COMPCODE_FAILURE)
	else
		{
		(*pr_state_pptr)->current_block = 8;
		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



enum { _block_origin = __LINE__ };
